// myhooks.h
// included, by automatic insertion, in every .{c,cc} file of a program
//   being analyzer

// it should never be multiply included, but this being here gives an
// easy way to turn *off* the hooks from the compiler command line
#ifndef __MYHOOKS_H
#define __MYHOOKS_H

// first, include stdlib.h, to get the regular definitions of malloc
// and free, and to prevent future inclusions of stdlib.h from
// messing anything up
#include <stdlib.h>

// grab the analysing-malloc declaration
#include "inst.h"

// map normal malloc and free into my versions
#define malloc instrumentingMalloc::malloc
#define free instrumentingMalloc::free

// define new versions of new and delete
void *operator new(size_t sz);
void operator delete(void *ptr);

#endif //__MYHOOKS_H

