// mypush.cc
// collecting necessary code to access root sets;
//   the meat of this code comes from the Boehm collector

#include "mypush.h"       // this module

#include <setjmp.h>       // setjmp
#include <string.h>       // memset


// this is what the Boehm collector uses
typedef void *ptr_t;

// claim is that, at least under Linux, _end is the last word
// (and __environ is the first); I hope this links...
extern int _end;
extern int __environ;


// what is actually used for Linux 
// (STACKBASE constant defined in gcconfig.h)
ptr_t GC_get_stack_base()
{
	return(((ptr_t)0xc0000000) );
}

bool traverseStack(TraversalFunc func, void *extra)
{
  int dummy;      // this will go on the stack, and mark its top
  return func(&dummy, GC_get_stack_base(), true /*isStack*/, extra);
}


bool traverseRoots(TraversalFunc func, void *extra)
{
#if 0      // suspect we may be picking up mostly trash
  // setjmp, in saving the "context", writes machine registers
  // into the buffer, which is on the stack
  jmp_buf regs;
  memset(&regs, 0, sizeof(regs));      // in case setjmp doesn't fill it
  setjmp(regs);
#endif // 0
  
  // traverse the stack
  if (!traverseStack(func, extra)) {
    return false;    // user cancelled iteration
  }

  // traverse the static data segment
  return func(&__environ, &_end, false /*isStack*/, extra);
}



