// mypush.h
// module to traverse the root set

#ifndef __MYPUSH_H
#define __MYPUSH_H

#include "typ.h"      // bool

// this is called for each region of memory in the root set
//   start    - pointer to first byte of region (alignment not guaranteed)
//   end      - pointer to last byte *plus one* of region
//   isStack  - true if this root segment is in the stack; false => static data
//   extra    - user argument to traverseRoots
//   returns  - true to continue, false to stop traversing
typedef bool (*TraversalFunc)(void *start, void *end, bool isStack, void *extra);


// call this to begin traversing
//   returns false if user-fn cancels
bool traverseRoots(TraversalFunc func, void *extra);


#endif // __MYPUSH_H
